#ifndef included
#error This script can only be compiled as a #include
#endif

#include "../../../lib/config.mi"

#define CUSTOM_OPTIONSMENU_ITEMS "{1828D28F-78DD-4647-8532-EBA504B8FC04}"
#define CUSTOM_WINDOWSMENU_ITEMS "{6559CA61-7EB2-4415-A8A9-A2AEEF762B7F}"
#define CUSTOM_PAGE "{9510C13C-8D23-4D68-8053-74CA06E402C2}"
#define CUSTOM_PAGE_NOTIFIER "{18370008-ED40-4BA2-8EE6-8DC227BB62F9}"
#define CUSTOM_PAGE_DRAWERS "{7EC95060-E71D-11D8-9669-0800200C9A66}"
#define CUSTOM_PAGE_STYLE "{094D9370-F0B7-11D8-9669-0800200C9A66}"
#define HIDDEN_PAGE "{C3A9CC21-E554-4DBC-945A-F6F7F187C68D}"

Function initAttribs();

Global ConfigAttribute configAttribute_eqVisible;

Global ConfigAttribute configAttribute_textScrolling;
Global ConfigAttribute configAttribute_unlinkShadePosition;

Global ConfigAttribute configAttribute_drawersHoverMode;
Global ConfigAttribute configAttribute_drawersFocusMode;
Global ConfigAttribute configAttribute_drawersLockOpen;
Global ConfigAttribute configAttribute_drawersAnimate;
Global ConfigAttribute configAttribute_drawersSnapAdjust;

Global ConfigAttribute configAttribute_styleDefaultAll;
Global ConfigAttribute configAttribute_styleCarbonAll;
Global ConfigAttribute configAttribute_styleDefaultWindows;
Global ConfigAttribute configAttribute_styleCarbonWindows;
Global ConfigAttribute configAttribute_styleDefaultHardButtons;
Global ConfigAttribute configAttribute_styleCarbonHardButtons;
Global ConfigAttribute configAttribute_styleDefaultSoftButtons;
Global ConfigAttribute configAttribute_styleCarbonSoftButtons;

Global ConfigAttribute configAttribute_notifierAlways;
Global ConfigAttribute configAttribute_notifierWindowshade;
Global ConfigAttribute configAttribute_notifierMinimized;
Global ConfigAttribute configAttribute_notifierNever;
Global ConfigAttribute configAttribute_notifierDisableFullscreen;
Global ConfigAttribute configAttribute_notifierHoldtime;
Global ConfigAttribute configAttribute_notifierPositionLeft;
Global ConfigAttribute configAttribute_notifierPositionRight;
Global ConfigAttribute configAttribute_notifierPositionTop;
Global ConfigAttribute configAttribute_notifierPositionBottom;
Global ConfigAttribute configAttribute_notifierNoAnimation;
Global ConfigAttribute configAttribute_notifierFade;
Global ConfigAttribute configAttribute_notifierSlideVertical;
Global ConfigAttribute configAttribute_notifierSlideHorizontal;
Global ConfigAttribute configAttribute_notifierSlideTime;

Global ConfigAttribute configAttribute_alwaysOnTop;
Global ConfigAttribute configAttribute_enableTooltips;
Global ConfigAttribute configAttribute_alternateFonts;
Global ConfigAttribute configAttribute_dockWindows;

Global ConfigAttribute configAttribute_system_alwaysOnTop;
Global ConfigAttribute configAttribute_system_enableTooltips;
Global ConfigAttribute configAttribute_system_alternateFonts;
Global ConfigAttribute configAttribute_system_dockWindows;

initAttribs() {
	ConfigItem custom_page = Config.newItem(System.getSkinName(), CUSTOM_PAGE);
	ConfigItem custom_page_notifier = Config.newItem("Notifications", CUSTOM_PAGE_NOTIFIER);
	ConfigItem custom_page_drawers = Config.newItem("Drawers", CUSTOM_PAGE_DRAWERS);
	ConfigItem custom_page_style = Config.newItem("Style", CUSTOM_PAGE_STYLE);
	ConfigItem hidden_page = Config.newItem(System.getSkinName() + " Hidden", HIDDEN_PAGE);
	ConfigItem custom_options_page = Config.getItem(CUSTOM_OPTIONSMENU_ITEMS);
	ConfigItem custom_windows_page = Config.getItem(CUSTOM_WINDOWSMENU_ITEMS);
	
	configAttribute_eqVisible = custom_windows_page.newAttribute("Equalizer\tAlt+G", "0");

	ConfigAttribute submenuattrib = custom_options_page.newAttribute(System.getSkinName(), "");
	ConfigAttribute notifiersubmenu = custom_page.newAttribute("Notifications", "");
	ConfigAttribute drawerssubmenu = custom_page.newAttribute("Drawers", "");
	ConfigAttribute stylesubmenu = custom_page.newAttribute("Style", "");
	
	submenuattrib.setData(CUSTOM_PAGE);

	configAttribute_textScrolling = custom_page.newAttribute("Enable Text Scrolling", "1");
	configAttribute_alwaysOnTop = custom_page.newAttribute("Always On Top", "0");
	configAttribute_enableTooltips = custom_page.newAttribute("Enable Tooltips", "1");
	configAttribute_dockWindows = custom_page.newAttribute("Dock Windows", "1");
	configAttribute_unlinkShadePosition = custom_page.newAttribute("Unlink Shade Position", "1");
	configAttribute_alternateFonts = custom_page.newAttribute("Alternate Fonts", "0");
	
	stylesubmenu.setData(CUSTOM_PAGE_STYLE);
	notifiersubmenu.setData(CUSTOM_PAGE_NOTIFIER);
	drawerssubmenu.setData(CUSTOM_PAGE_DRAWERS);
	
	configAttribute_styleDefaultAll = custom_page_style.newAttribute("All Default", "1");
	configAttribute_styleCarbonAll = custom_page_style.newAttribute("All Carbon", "0");
	ConfigAttribute sep6 = custom_page_style.newAttribute("sep6", ""); sep6.setData("-");
	configAttribute_styleDefaultWindows = custom_page_style.newAttribute("Default Windows", "1");
	configAttribute_styleCarbonWindows = custom_page_style.newAttribute("Carbon Windows", "0");
	ConfigAttribute sep7 = custom_page_style.newAttribute("sep7", ""); sep7.setData("-");
	configAttribute_styleDefaultHardButtons = custom_page_style.newAttribute("Default Hard Buttons", "1");
	configAttribute_styleCarbonHardButtons = custom_page_style.newAttribute("Carbon Hard Buttons", "0");
	ConfigAttribute sep8 = custom_page_style.newAttribute("sep8", ""); sep8.setData("-");
	configAttribute_styleDefaultSoftButtons = custom_page_style.newAttribute("Default Soft Buttons", "1");
	configAttribute_styleCarbonSoftButtons = custom_page_style.newAttribute("Carbon Soft Buttons", "0");

	configAttribute_notifierAlways = custom_page_notifier.newAttribute("Show Always", "1");
	configAttribute_notifierWindowshade = custom_page_notifier.newAttribute("Show With Shade And When Minimized", "0");
	configAttribute_notifierMinimized = custom_page_notifier.newAttribute("Show Only When Minimized", "0");
	configAttribute_notifierNever = custom_page_notifier.newAttribute("Never Show", "0");
	ConfigAttribute sep1 = custom_page_notifier.newAttribute("sep1", ""); sep1.setData("-");
	configAttribute_notifierDisableFullscreen = custom_page_notifier.newAttribute("Disable In Fullscreen", "1");
	ConfigAttribute sep2 = custom_page_notifier.newAttribute("sep2", ""); sep2.setData("-");
	configAttribute_notifierPositionTop = custom_page_notifier.newAttribute("Appears On Top", "0");
	configAttribute_notifierPositionBottom = custom_page_notifier.newAttribute("Appears On Bottom", "1");
	ConfigAttribute sep9 = custom_page_notifier.newAttribute("sep9", ""); sep9.setData("-");
	configAttribute_notifierPositionLeft = custom_page_notifier.newAttribute("Appears On Left", "0");
	configAttribute_notifierPositionRight = custom_page_notifier.newAttribute("Appears On Right", "1");
	ConfigAttribute sep3 = custom_page_notifier.newAttribute("sep3", ""); sep3.setData("-");
	configAttribute_notifierNoAnimation = custom_page_notifier.newAttribute("No Animation", "0");
	configAttribute_notifierFade = custom_page_notifier.newAttribute("Fade In/Out", "0");
	configAttribute_notifierSlideVertical = custom_page_notifier.newAttribute("Slide Vertically", "0");
	configAttribute_notifierSlideHorizontal = custom_page_notifier.newAttribute("Slide Horizontally", "1");
	
	configAttribute_drawersHoverMode = custom_page_drawers.newAttribute("Hover Mode", "1");
	configAttribute_drawersFocusMode = custom_page_drawers.newAttribute("Focus Mode", "0");
	ConfigAttribute sep4 = custom_page_drawers.newAttribute("sep4", ""); sep4.setData("-");
	configAttribute_drawersLockOpen = custom_page_drawers.newAttribute("Lock Open", "0");
	ConfigAttribute sep5 = custom_page_drawers.newAttribute("sep5", ""); sep5.setData("-");
	configAttribute_drawersAnimate = custom_page_drawers.newAttribute("Animate Drawers", "1");
	configAttribute_drawersSnapAdjust = custom_page_drawers.newAttribute("SnapAdjust Docked Windows", "1");
	
	configAttribute_notifierHoldtime = hidden_page.newAttribute("Notifications Display Time", "5000");
	configAttribute_notifierSlideTime = hidden_page.newAttribute("Notifications Slide Time", "1");

	ConfigItem ciMisc;
	ciMisc = Config.getItem("Options");
	if (ciMisc != NULL) {
		configAttribute_system_alwaysOnTop = ciMisc.getAttribute("Always on top");
		configAttribute_system_alternateFonts = ciMisc.getAttribute("Alternate Fonts");
		configAttribute_system_dockWindows = ciMisc.getAttribute("Enable docking");
	}

	ciMisc = Config.getItem("Skins and UI Tweaks");
	if (ciMisc != NULL) {
		configAttribute_system_enableTooltips = ciMisc.getAttribute("Enable tooltips");
	}
	
	configAttribute_alwaysOnTop.setData(configAttribute_system_alwaysOnTop.getData());
	configAttribute_alternateFonts.setData(configAttribute_system_alternateFonts.getData());
	configAttribute_dockWindows.setData(configAttribute_system_dockWindows.getData());
	configAttribute_enableTooltips.setData(configAttribute_system_enableTooltips.getData());
}

#ifdef MAIN_ATTRIBS_MGR

#define NOOFF if (getData() == "0") { setData("1"); return; }

Global Boolean boolMyChange;

configAttribute_alwaysOnTop.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_system_alwaysOnTop.setData(getData());
	boolMyChange = false;
}
configAttribute_system_alwaysOnTop.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_alwaysOnTop.setData(getData());
	boolMyChange = false;
}

configAttribute_enableTooltips.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_system_enableTooltips.setData(getData());
	boolMyChange = false;
}
configAttribute_system_enableTooltips.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_enableTooltips.setData(getData());
	boolMyChange = false;
}

configAttribute_alternateFonts.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_system_alternateFonts.setData(getData());
	boolMyChange = false;
}
configAttribute_system_alternateFonts.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_alternateFonts.setData(getData());
	boolMyChange = false;
}

configAttribute_dockWindows.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_system_dockWindows.setData(getData());
	boolMyChange = false;
}
configAttribute_system_dockWindows.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_dockWindows.setData(getData());
	boolMyChange = false;
}

configAttribute_drawersHoverMode.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_drawersFocusMode.setData("0");
	boolMyChange = false;
}

configAttribute_drawersFocusMode.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_drawersHoverMode.setData("0");
	boolMyChange = false;
}

configAttribute_notifierAlways.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNever.setData("0");
	configAttribute_notifierWindowshade.setData("0");
	configAttribute_notifierMinimized.setData("0");
	boolMyChange = false;
}

configAttribute_notifierNever.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierAlways.setData("0");
	configAttribute_notifierWindowshade.setData("0");
	configAttribute_notifierMinimized.setData("0");
	boolMyChange = false;
}

configAttribute_notifierMinimized.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNever.setData("0");
	configAttribute_notifierWindowshade.setData("0");
	configAttribute_notifierAlways.setData("0");
	boolMyChange = false;
}

configAttribute_notifierWindowshade.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNever.setData("0");
	configAttribute_notifierAlways.setData("0");
	configAttribute_notifierMinimized.setData("0");
	boolMyChange = false;
}

configAttribute_notifierPositionTop.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierPositionBottom.setData("0");
	boolMyChange = false;
}

configAttribute_notifierPositionBottom.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierPositionTop.setData("0");
	boolMyChange = false;
}

configAttribute_notifierPositionLeft.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierPositionRight.setData("0");
	boolMyChange = false;
}

configAttribute_notifierPositionRight.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierPositionLeft.setData("0");
	boolMyChange = false;
}

configAttribute_notifierNoAnimation.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierFade.setData("0");
	configAttribute_notifierSlideHorizontal.setData("0");
	configAttribute_notifierSlideVertical.setData("0");
	boolMyChange = false;
}

configAttribute_notifierFade.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNoAnimation.setData("0");
	configAttribute_notifierSlideVertical.setData("0");
	configAttribute_notifierSlideHorizontal.setData("0");
	boolMyChange = false;
}

configAttribute_notifierSlideVertical.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNoAnimation.setData("0");
	configAttribute_notifierFade.setData("0");
	configAttribute_notifierSlideHorizontal.setData("0");
	
	boolMyChange = false;
}

configAttribute_notifierSlideHorizontal.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	configAttribute_notifierNoAnimation.setData("0");
	configAttribute_notifierFade.setData("0");
	configAttribute_notifierSlideVertical.setData("0");
	boolMyChange = false;
}

#endif