Function initGlobal();
Function unloadGlobal();
Function showActionInfo(String strValue);
Function Boolean mouseIsOverGuiObject(GuiObject guiTarget, Boolean boolShortMode);
Function slideGroup(Group groupSlide, Int intFinalPosX, Int intFinalPosY, Int intFinalA, Float fltSpeed, Boolean boolAnimated); 
Function animateButtonLED(GuiObject guiLED, Int intFinalA);
Function showSkinOptionsMenu();

Global Container containerMain;
Global Container containerPL;
Global Container containerAVS;
Global Container containerVID;
Global Layout layoutMainNormal;
Global Layout layoutMainShade;
Global Layout layoutPLNormal;
Global Layout layoutPLShade;
Global Layout layoutAVSNormal;
Global Layout layoutVIDNormal;
Global Layout layoutAlbumCoverNormal;
Global Text textNormalSongInfo;
Global Text textShadeSongInfo;
Global Text textNormalActionInfo;
Global Text textShadeActionInfo;
Global Text textPLShadeSongInfo;
Global Timer timerSongTicker;
Global Boolean boolReleaseSongTicker;

initGlobal() {
	containerMain = System.getContainer("main");
	containerPL = System.getContainer("pledit");
	containerAVS = System.getContainer("avs_window");
	containerVID = System.getContainer("video");
	
	layoutMainNormal = containerMain.getLayout("normal");
	layoutMainShade = containerMain.getLayout("shade");
	layoutPLNormal = containerPL.getLayout("normal");
	layoutPLShade = containerPL.getLayout("shade");
	layoutAVSNormal = containerAVS.getLayout("normal");
	layoutVIDNormal = containerVID.getLayout("normal");
	
	textNormalSongInfo = layoutMainNormal.findObject("player.songname");
	textShadeSongInfo = layoutMainShade.findObject("player.songname");
	textNormalActionInfo = layoutMainNormal.findObject("player.actioninfo");
	textShadeActionInfo = layoutMainShade.findObject("player.actioninfo");
	textPLShadeSongInfo = layoutPLShade.findObject("pledit.songname");
	
	textNormalActionInfo.hide();
	textShadeActionInfo.hide();
	
	timerSongTicker = new Timer;
	timerSongTicker.setDelay(1000);
	boolReleaseSongTicker = true;
}

unloadGlobal() {
	delete timerSongTicker;
}

timerSongTicker.onTimer() {
	if (boolReleaseSongTicker) {
		textNormalActionInfo.hide();
		textShadeActionInfo.hide();
		textNormalSongInfo.show();
		textShadeSongInfo.show();
		timerSongTicker.stop();
	}
}

showActionInfo(String strValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	
	textNormalSongInfo.hide();
	textNormalActionInfo.show();
	textNormalActionInfo.setText(strValue);
	
	textShadeSongInfo.hide();
	textShadeActionInfo.show();
	textShadeActionInfo.setText(strValue);
}

Boolean mouseIsOverGuiObject(GuiObject guiTarget, Boolean boolShortMode) {
	Int intMousePosX = System.getMousePosX();
	Int intMousePosY = System.getMousePosY();
	
	Int intShortModeOffset;
	
	if (boolShortMode) {
		intShortModeOffset = 155;
	} else {
		intShortModeOffset = 0;
	}
	
	Boolean boolInLayoutH = intMousePosX >= guiTarget.getLeft() && intMousePosX <= (guiTarget.getLeft() + guiTarget.getWidth());
	Boolean boolInLayoutV = intMousePosY >= guiTarget.getTop() && intMousePosY <= (guiTarget.getTop() + guiTarget.getHeight() - intShortModeOffset);
	
	if (boolInLayoutH && boolInLayoutV) {
		return true;
	} else {
		return false;
	}
}

slideGroup(Group groupSlide, Int intFinalPosX, Int intFinalPosY, Int intFinalA, Float fltSpeed, Boolean boolAnimated) {
	if (boolAnimated) {
		groupSlide.setTargetX(intFinalPosX);
		groupSlide.setTargetY(intFinalPosY);
		groupSlide.setTargetA(intFinalA);
		groupSlide.setTargetSpeed(fltSpeed);
		groupSlide.gotoTarget();
	} else {
		groupSlide.setXMLParam("x", System.integerToString(intFinalPosX));
		groupSlide.setXMLParam("y", System.integerToString(intFinalPosY));
		groupSlide.setXMLParam("alpha", System.integerToString(intFinalA));
	}
}

animateButtonLED(GuiObject guiLED, Int intFinalA) {
	guiLED.setTargetA(intFinalA);
	guiLED.setTargetSpeed(0.25);
	guiLED.gotoTarget();
}

showSkinOptionsMenu() {
	PopupMenu popupMenuSkinOptions = new PopupMenu;
	PopupMenu popupMenuNotifierOptions = new PopupMenu;
	PopupMenu popupMenuNotifierHoldTime = new PopupMenu;
	PopupMenu popupMenuDrawerOptions = new PopupMenu;
	PopupMenu popupMenuStyleOptions = new PopupMenu;
	
	Boolean boolScrollTicker = System.stringToInteger(configAttribute_textScrolling.getData());
	Boolean boolAlwaysOnTop = System.stringToInteger(configAttribute_alwaysOnTop.getData());
	Boolean boolEnableTooltips = System.stringToInteger(configAttribute_enableTooltips.getData());
	Boolean boolDockWindows = System.stringToInteger(configAttribute_dockWindows.getData());
	Boolean boolUnlinkShadePosition = System.stringToInteger(configAttribute_unlinkShadePosition.getData());
	Boolean boolAlternateFonts = System.stringToInteger(configAttribute_alternateFonts.getData());

	Boolean boolDrawersHoverMode = System.stringToInteger(configAttribute_drawersHoverMode.getData());
	Boolean boolDrawersFocusMode = System.stringToInteger(configAttribute_drawersFocusMode.getData());
	Boolean boolDrawersLockOpen = System.stringToInteger(configAttribute_drawersLockOpen.getData());
	Boolean boolAnimateDrawers = System.stringToInteger(configAttribute_drawersAnimate.getData());
	Boolean boolSnapAdjustDockedWindows = System.stringToInteger(configAttribute_drawersSnapAdjust.getData());
	
	Boolean boolNotifierAlways = System.stringToInteger(configAttribute_notifierAlways.getData());
	Boolean boolNotifierWindowshade = System.stringToInteger(configAttribute_notifierWindowshade.getData());
	Boolean boolNotifierMinimized = System.stringToInteger(configAttribute_notifierMinimized.getData());
	Boolean boolNotifierNever = System.stringToInteger(configAttribute_notifierNever.getData());
	Boolean boolNotifierDisableFullscreen = System.stringToInteger(configAttribute_notifierDisableFullscreen.getData());
	Boolean boolNotifierPositionTop = System.stringToInteger(configAttribute_notifierPositionTop.getData());
	Boolean boolNotifierPositionBottom = System.stringToInteger(configAttribute_notifierPositionBottom.getData());
	Boolean boolNotifierPositionLeft = System.stringToInteger(configAttribute_notifierPositionLeft.getData());
	Boolean boolNotifierPositionRight = System.stringToInteger(configAttribute_notifierPositionRight.getData());
	Boolean boolNotifierNoAnimation = System.stringToInteger(configAttribute_notifierNoAnimation.getData());
	Boolean boolNotifierFade = System.stringToInteger(configAttribute_notifierFade.getData());
	Boolean boolNotifierSlideVertical = System.stringToInteger(configAttribute_notifierSlideVertical.getData());
	Boolean boolNotifierSlideHorizontal = System.stringToInteger(configAttribute_notifierSlideHorizontal.getData());
	
	Boolean boolStyleDefaultAll = System.stringToInteger(configAttribute_styleDefaultAll.getData());
	Boolean boolStyleCarbonAll = System.stringToInteger(configAttribute_styleCarbonAll.getData());
	Boolean boolStyleDefaultWindows = System.stringToInteger(configAttribute_styleDefaultWindows.getData());
	Boolean boolStyleCarbonWindows = System.stringToInteger(configAttribute_styleCarbonWindows.getData());
	Boolean boolStyleDefaultHardButtons = System.stringToInteger(configAttribute_styleDefaultHardButtons.getData());
	Boolean boolStyleCarbonHardButtons = System.stringToInteger(configAttribute_styleCarbonHardButtons.getData());
	Boolean boolStyleDefaultSoftButtons = System.stringToInteger(configAttribute_styleDefaultSoftButtons.getData());
	Boolean boolStyleCarbonSoftButtons = System.stringToInteger(configAttribute_styleCarbonSoftButtons.getData());
	
	Int intNotifierHoldTime = System.stringToInteger(configAttribute_notifierHoldtime.getData());
	
	popupMenuStyleOptions.addCommand("All Default",26,boolStyleDefaultAll,0);
	popupMenuStyleOptions.addCommand("All Carbon",27,boolStyleCarbonAll,0);
	popupMenuStyleOptions.addSeparator();
	popupMenuStyleOptions.addCommand("Default Windows",28,boolStyleDefaultWindows,0);
	popupMenuStyleOptions.addCommand("Carbon Windows",29,boolStyleCarbonWindows,0);
	popupMenuStyleOptions.addSeparator();
	popupMenuStyleOptions.addCommand("Default Hard Buttons",30,boolStyleDefaultHardButtons,0);
	popupMenuStyleOptions.addCommand("Carbon Hard Buttons",31,boolStyleCarbonHardButtons,0);
	popupMenuStyleOptions.addSeparator();
	popupMenuStyleOptions.addCommand("Default Soft Buttons",32,boolStyleDefaultSoftButtons,0);
	popupMenuStyleOptions.addCommand("Carbon Soft Buttons",33,boolStyleCarbonSoftButtons,0);
	
	popupMenuDrawerOptions.addCommand("Hover Mode",7,boolDrawersHoverMode,0);
	popupMenuDrawerOptions.addCommand("Focus Mode",8,boolDrawersFocusMode,0);
	popupMenuDrawerOptions.addSeparator();
	popupMenuDrawerOptions.addCommand("Lock Open",9,boolDrawersLockOpen,0);
	popupMenuDrawerOptions.addSeparator();
	popupMenuDrawerOptions.addCommand("Animate Drawers",10,boolAnimateDrawers,0);
	popupMenuDrawerOptions.addCommand("SnapAdjust Docked windows",11,boolSnapAdjustDockedWindows,0);
	
	popupMenuNotifierHoldTime.addCommand("0 seconds",21,(intNotifierHoldTime == 0),0);
	popupMenuNotifierHoldTime.addCommand("5 seconds",22,(intNotifierHoldTime == 5000),0);
	popupMenuNotifierHoldTime.addCommand("10 seconds",23,(intNotifierHoldTime == 10000),0);
	popupMenuNotifierHoldTime.addCommand("15 seconds",24,(intNotifierHoldTime == 15000),0);
	popupMenuNotifierHoldTime.addCommand("20 seconds",25,(intNotifierHoldTime == 20000),0);
	
	popupMenuNotifierOptions.addCommand("Show Always",12,boolNotifierAlways,0);
	popupMenuNotifierOptions.addCommand("Show With Shade And When Minimized",13,boolNotifierWindowshade,0);
	popupMenuNotifierOptions.addCommand("Show Only When Minimized",14,boolNotifierMinimized,0);
	popupMenuNotifierOptions.addCommand("Never Show",15,boolNotifierNever,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Disable In Fullscreen",16,boolNotifierDisableFullscreen,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Appears On Top",34,boolNotifierPositionTop,0);
	popupMenuNotifierOptions.addCommand("Appears On Bottom",35,boolNotifierPositionBottom,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Appears On Left",17,boolNotifierPositionLeft,0);
	popupMenuNotifierOptions.addCommand("Appears On Right",18,boolNotifierPositionRight,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("No Animation",37,boolNotifierNoAnimation,0);
	popupMenuNotifierOptions.addCommand("Fade In/Out",36,boolNotifierFade,0);
	popupMenuNotifierOptions.addCommand("Slide Vertically",19,boolNotifierSlideVertical,0);
	popupMenuNotifierOptions.addCommand("Slide Horizontally",20,boolNotifierSlideHorizontal,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addSubMenu(popupMenuNotifierHoldTime, "Hold Time");
	
	popupMenuSkinOptions.addCommand("Enable Text Scrolling",1,boolScrollTicker,0);
	popupMenuSkinOptions.addCommand("Always On Top",2,boolAlwaysOnTop,0);
	popupMenuSkinOptions.addCommand("Enable Tooltips",3,boolEnableTooltips,0);
	popupMenuSkinOptions.addCommand("Dock Windows",4,boolDockWindows,0);
	popupMenuSkinOptions.addCommand("Unlink Shade Position",5,boolUnlinkShadePosition,0);
	popupMenuSkinOptions.addCommand("Alternate Fonts",6,boolAlternateFonts,0);
	popupMenuSkinOptions.addSubMenu(popupMenuNotifierOptions, "Notifications");
	popupMenuSkinOptions.addSubMenu(popupMenuDrawerOptions, "Drawers");
	popupMenuSkinOptions.addSubMenu(popupMenuStyleOptions, "Style");
	
	Int intSelectedOption = popupMenuSkinOptions.popAtMouse();
	
	if (intSelectedOption == 1) configAttribute_textScrolling.setData(System.integerToString(!boolScrollTicker));
	else if (intSelectedOption == 2) configAttribute_alwaysOnTop.setData(System.integerToString(!boolAlwaysOnTop));
	else if (intSelectedOption == 3) configAttribute_enableTooltips.setData(System.integerToString(!boolEnableTooltips));
	else if (intSelectedOption == 4) configAttribute_dockWindows.setData(System.integerToString(!boolDockWindows));
	else if (intSelectedOption == 5) configAttribute_unlinkShadePosition.setData(System.integerToString(!boolUnlinkShadePosition));
	else if (intSelectedOption == 6) configAttribute_alternateFonts.setData(System.integerToString(!boolAlternateFonts));
	else if (intSelectedOption == 7) configAttribute_drawersHoverMode.setData(System.integerToString(!boolDrawersHoverMode));
	else if (intSelectedOption == 8) configAttribute_drawersFocusMode.setData(System.integerToString(!boolDrawersFocusMode));
	else if (intSelectedOption == 9) configAttribute_drawersLockOpen.setData(System.integerToString(!boolDrawersLockOpen));
	else if (intSelectedOption == 10) configAttribute_drawersAnimate.setData(System.integerToString(!boolAnimateDrawers));
	else if (intSelectedOption == 11) configAttribute_drawersSnapAdjust.setData(System.integerToString(!boolSnapAdjustDockedWindows));
	else if (intSelectedOption == 12) configAttribute_notifierAlways.setData("1");
	else if (intSelectedOption == 13) configAttribute_notifierWindowshade.setData("1");
	else if (intSelectedOption == 14) configAttribute_notifierMinimized.setData("1");
	else if (intSelectedOption == 15) configAttribute_notifierNever.setData("1");
	else if (intSelectedOption == 16) configAttribute_notifierDisableFullscreen.setData(System.integerToString(!boolNotifierDisableFullscreen));
	else if (intSelectedOption == 17) configAttribute_notifierPositionLeft.setData(System.integerToString(!boolNotifierPositionLeft));
	else if (intSelectedOption == 18) configAttribute_notifierPositionRight.setData(System.integerToString(!boolNotifierPositionRight));
	else if (intSelectedOption == 19) configAttribute_notifierSlideVertical.setData(System.integerToString(!boolNotifierSlideVertical));
	else if (intSelectedOption == 20) configAttribute_notifierSlideHorizontal.setData(System.integerToString(!boolNotifierSlideHorizontal));
	else if (intSelectedOption == 21) configAttribute_notifierHoldtime.setData("0");
	else if (intSelectedOption == 22) configAttribute_notifierHoldtime.setData("5000");
	else if (intSelectedOption == 23) configAttribute_notifierHoldtime.setData("10000");
	else if (intSelectedOption == 24) configAttribute_notifierHoldtime.setData("15000");
	else if (intSelectedOption == 25) configAttribute_notifierHoldtime.setData("20000");
	else if (intSelectedOption == 26) configAttribute_styleDefaultAll.setData(System.integerToString(!boolStyleDefaultAll));
	else if (intSelectedOption == 27) configAttribute_styleCarbonAll.setData(System.integerToString(!boolStyleCarbonAll));
	else if (intSelectedOption == 28) configAttribute_styleDefaultWindows.setData(System.integerToString(!boolStyleDefaultWindows));
	else if (intSelectedOption == 29) configAttribute_styleCarbonWindows.setData(System.integerToString(!boolStyleCarbonWindows));
	else if (intSelectedOption == 30) configAttribute_styleDefaultHardButtons.setData(System.integerToString(!boolStyleDefaultHardButtons));
	else if (intSelectedOption == 31) configAttribute_styleCarbonHardButtons.setData(System.integerToString(!boolStyleCarbonHardButtons));
	else if (intSelectedOption == 32) configAttribute_styleDefaultSoftButtons.setData(System.integerToString(!boolStyleDefaultSoftButtons));
	else if (intSelectedOption == 33) configAttribute_styleCarbonSoftButtons.setData(System.integerToString(!boolStyleCarbonSoftButtons));
	else if (intSelectedOption == 34) configAttribute_notifierPositionTop.setData(System.integerToString(!boolNotifierPositionTop));
	else if (intSelectedOption == 35) configAttribute_notifierPositionBottom.setData(System.integerToString(!boolNotifierPositionBottom));
	else if (intSelectedOption == 36) configAttribute_notifierFade.setData(System.integerToString(!boolNotifierFade));
	else if (intSelectedOption == 37) configAttribute_notifierNoAnimation.setData(System.integerToString(!boolNotifierNoAnimation));
	
	delete popupMenuNotifierHoldTime;
	delete popupMenuNotifierOptions;
	delete popupMenuDrawerOptions;
	delete popupMenuStyleOptions;
	delete popupMenuSkinOptions;
	
	complete;
}