#include "../../../lib/std.mi"

Function setFillbar(Int intValue);

Global Group groupScript;
Global GuiObject guiFillbarVertical;
Global GuiObject guiFillbarHorizontal;
Global Slider sliderParent;
Global String strOrientation;
Global Int intStartHeight;
Global Int intStartWidth;
Global Float fltRangeLow;
Global Float fltRangeHigh;
Global Float fltRangeTotal = 999;
Global Int intGripAdjust = 999;
Global Int intPreviousValue;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	guiFillbarVertical = groupScript.findobject("fillbar.vertical");
	guiFillbarHorizontal = groupScript.findobject("fillbar.horizontal");
	
	intStartHeight = System.stringToInteger(groupScript.getXMLParam("h"));
	intStartWidth = System.stringToInteger(groupScript.getXMLParam("w"));
	
	guiFillbarVertical.hide();
	guiFillbarHorizontal.hide();
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "orientation") {
		strOrientation = System.strLower(strValue);
		if (strOrientation == "vertical") {
			guiFillbarVertical.show();
		} else if (strOrientation == "horizontal") {
			guiFillbarHorizontal.show();
		}
	}
	
	if (System.strLower(strParam) == "gripadjust") intGripAdjust = System.stringtoInteger(strValue);
	
	if (System.strLower(strParam) == "range") {
		fltRangeLow = System.stringToFloat(System.getToken(strValue, ",", 0));
		fltRangeHigh = System.stringToFloat(System.getToken(strValue, ",", 1));
		fltRangeTotal = fltRangeHigh - fltRangeLow;
	}
	
	if (System.strLower(strParam) == "parentslider") {
		sliderParent = groupScript.getParentLayout().findObject(strValue);
		sliderParent.bringToFront();
	}
	
	if (sliderParent != NULL && intGripAdjust != 999 && strOrientation != "" && fltRangeTotal != 999) {
		setFillbar(sliderParent.getPosition());
	}
}

System.onEqBandChanged(Int intBand, Int intValue) { setFillbar(sliderParent.getPosition()); }
System.onEqPreampChanged(Int intValue) { setFillbar(sliderParent.getPosition()); }
sliderParent.onSetFinalPosition(Int intValue) { setFillbar(intValue); }
sliderParent.onSetPosition(Int intValue) { setFillbar(intValue); }
sliderParent.onPostedPosition(Int intValue) { setFillbar(intValue); }

setFillbar(Int intValue) {
	Int intPosition;
	Int intLength;
	Int intScaledValue;
	Int intScaledAdjust;
	
	intValue = intValue - fltRangeLow;
	if (intGripAdjust != 0) {
		intScaledAdjust = ((intValue * intGripAdjust / fltRangeTotal) - (intGripAdjust / 2)) * -1;
	}
	
	if (strOrientation == "vertical") {
		intScaledValue = intValue * intStartHeight / fltRangeTotal;
		intPosition = intStartHeight - intScaledValue - intScaledAdjust;
		intLength = intScaledValue - intStartHeight + intScaledAdjust;
		if (guiFillbarVertical.getGuiY() != intPosition && guiFillbarVertical.getGuiH() != intLength) {
			guiFillbarVertical.setXMLParam("y", System.integerToString(intPosition));
			guiFillbarVertical.setXMLParam("h", System.integerToString(intLength));
		}
	} else if (strOrientation == "horizontal") {
		intScaledValue = intValue * intStartWidth / fltRangeTotal;
		intLength = (intStartWidth - intScaledValue - intScaledAdjust) * -1;
		if (guiFillbarHorizontal.getGuiW() != intLength) {
			guiFillbarHorizontal.setXMLParam("w", System.integerToString(intLength));
		}
	}
}