Function initNotifierHoldTime();
Function unloadNotifierHoldTime();
Function setNotifierHoldTimeAnimation(Int intPosition);
Function updateNotifierHoldTime(Int intPosX, Int intPosY);

Global AnimatedLayer layerMainNormalNotifierHoldTime;
Global Map mapMainNormalNotifierHoldTime;
Global Boolean boolNotifierHoldTimeChanging;

initNotifierHoldTime() {
	layerMainNormalNotifierHoldTime = layoutMainNormal.findObject("player.notifier.holdtime");
	mapMainNormalNotifierHoldTime = new Map;
	mapMainNormalNotifierHoldTime.loadMap("player.normal.map.notifier.holdtime");
	
	setNotifierHoldTimeAnimation(System.stringToInteger(configAttribute_notifierHoldtime.getData()) / 1000);
}

unloadNotifierHoldTime() {
	delete mapMainNormalNotifierHoldTime;
}

layerMainNormalNotifierHoldTime.onLeftButtonDown(Int intPosX, Int intPosY) {
	boolNotifierHoldTimeChanging = true;
	updateNotifierHoldTime(intPosX, intPosY);
}

layerMainNormalNotifierHoldTime.onLeftButtonUp(Int intPosX, Int intPosY) {
	if (boolNotifierHoldTimeChanging) {
		boolNotifierHoldTimeChanging = false;
		boolReleaseSongTicker = true;
		updateNotifierHoldTime(intPosX, intPosY);
	}
}

layerMainNormalNotifierHoldTime.onMouseMove(Int intPosX, Int intPosY) {
	if (boolNotifierHoldTimeChanging) {
		updateNotifierHoldTime(intPosX, intPosY);
	}
}

configAttribute_notifierHoldtime.onDataChanged() {
  Int intValue = System.stringToInteger(configAttribute_notifierHoldtime.getData());
  setNotifierHoldTimeAnimation(intValue / 1000);
}

setNotifierHoldTimeAnimation(Int intValueSeconds) {
	if (intValueSeconds <= (layerMainNormalNotifierHoldTime.getLength() - 1)) {
		layerMainNormalNotifierHoldTime.gotoFrame(intValueSeconds);
	} else {
		layerMainNormalNotifierHoldTime.gotoFrame(layerMainNormalNotifierHoldTime.getLength() - 1);
	}
}

updateNotifierHoldTime(Int intPosX, Int intPosY) {
	Int intNewValue = mapMainNormalNotifierHoldTime.getValue(intPosX, intPosY);
	Int intValueSeconds = (intNewValue * (layerMainNormalNotifierHoldTime.getLength() - 1)) / 255;
	setNotifierHoldTimeAnimation(intValueSeconds);
	configAttribute_notifierHoldtime.setData(System.integerToString(intValueSeconds * 1000));
	showActionInfo("Hold Time: " + System.integerToString(intValueSeconds) + " SECONDS");
}