Function initSeek();
Function unloadSeek();
Function setSeekAnimation(Int intPosition);
Function updateSeekGhost(Int intPosX, Int intPosY);
Function updateSeek(Int intPosX, Int intPosY);

Global AnimatedLayer layerMainNormalSeek;
Global Map mapMainNormalSeek;
Global Boolean boolSeekChanging;
Global Timer timerSeek;

initSeek() {
	layerMainNormalSeek = layoutMainNormal.findObject("player.seek.progress");
	
	mapMainNormalSeek = new Map;
	mapMainNormalSeek.loadMap("player.normal.map.seek");
	
	timerSeek = new Timer;
	timerSeek.setDelay(750);
	
	if (System.getPlayItemString() != "") {
		setSeekAnimation((System.getPosition() / System.getPlayItemLength()) * 255);
		timerSeek.start();
	} else {
		setSeekAnimation(255);
	}
}

unloadSeek() {
	timerSeek.stop();
	delete timerSeek;
	delete mapMainNormalSeek;
}

timerSeek.onTimer() {
	setSeekAnimation((System.getPosition() / System.getPlayItemLength()) * 255);
}

layerMainNormalSeek.onLeftButtonDown(Int intPosX, Int intPosY) {
	timerSeek.stop();
	boolSeekChanging = true;
	updateSeekGhost(intPosX, intPosY);
}

layerMainNormalSeek.onLeftButtonUp(Int intPosX, Int intPosY) {
	timerSeek.start();
	if (boolSeekChanging) {
		boolSeekChanging = false;
		boolReleaseSongTicker = true;
		updateSeek(intPosX, intPosY);
	}
}

layerMainNormalSeek.onMouseMove(Int intPosX, Int intPosY) {
	if (boolSeekChanging) {
		updateSeekGhost(intPosX, intPosY);
	}
}

setSeekAnimation(Int intPosition) {
	if (System.getPlayItemLength() > 0) {
		Int intFrame = (intPosition * (layerMainNormalSeek.getLength() - 1)) / 255;
		if (intPosition > 0 && intPosition != 255) {
			intFrame = intFrame + 1;
		} else if (intPosition == 0) {
			intFrame = 1;
		}
		layerMainNormalSeek.gotoFrame(intFrame);
	} else {
		layerMainNormalSeek.gotoFrame(layerMainNormalSeek.getLength() - 1);
	}
}

updateSeekGhost(Int intPosX, Int intPosY) {
	if (System.getPlayItemLength() > 0) {
		Int intNewValue = mapMainNormalSeek.getValue(intPosX, intPosY);
		Float floatPositionPercentage = intNewValue / 255 * 100;
		Float floatPlayItemLength = System.getPlayItemLength();
		Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
		setSeekAnimation(intNewValue);
		showActionInfo("SEEK TO: " + System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
	}
}

updateSeek(Int intPosX, Int intPosY) {
	if (System.getPlayItemLength() > 0) {
		Int intNewPosition = mapMainNormalSeek.getValue(intPosX, intPosY);
		System.seekTo(System.getPlayItemLength() * (intNewPosition / 255));
	}
}