#include "../../../lib/std.mi"
#include "attribs.m"
#include "utility.m"

Function setNewGroup(String strGroupID);
Function initStyle();
Function syncStyle();

Global Layout layoutStandardFrame;
Global Group groupStandardFrame;
Global Group groupStandardFrameContent;
Global Group groupStandardFrameTitlebar;
Global Layer layerMouseTrap;
Global String strParamX, strParamY, strParamW, strParamH, strParamRX, strParamRY, strParamRW, strParamRH;

Global String strStandardFrameStyleTargetsBackgrounds1;
Global String strStandardFrameStyleTargetsBackgrounds2;
Global String strStandardFrameStyleTargetsBackgrounds3;
Global String strStandardFrameStyleTargetsSoftButtons;

System.onScriptLoaded() {
	groupStandardFrame = System.getScriptGroup();
	layoutStandardFrame = groupStandardFrame.getParentLayout();
	
	String strParam = System.getParam();
	strParamX = System.getToken(strParam, ",", 0);
	strParamY = System.getToken(strParam, ",", 1);
	strParamW = System.getToken(strParam, ",", 2);
	strParamH = System.getToken(strParam, ",", 3);
	strParamRX = System.getToken(strParam, ",", 4);
	strParamRY = System.getToken(strParam, ",", 5);
	strParamRW = System.getToken(strParam, ",", 6);
	strParamRH = System.getToken(strParam, ",", 7);
	
	initAttribs();
	initStyle();
}

System.onSetXuiParam(String strParam, String strValue) {
	if (strParam == "content") {
		setNewGroup(strValue);
		groupStandardFrameTitlebar = groupStandardFrame.findObject("wasabi.titlebar");
		if (groupStandardFrameTitlebar != NULL) {
			layerMouseTrap = groupStandardFrameTitlebar.findObject("mousetrap");
		}
	}
	if (strParam == "padtitleright" || strParam == "padtitleleft") {
		if (groupStandardFrameTitlebar != NULL) {
			groupStandardFrameTitlebar.setXMLParam(strParam, strValue);
		}
	}
	if (strParam == "shade") {
		if (layerMouseTrap != NULL) {
			layerMouseTrap.setXMLParam("dblclickaction", "switch;" + strValue);
		} else {
			messagebox("Cannot set shade parameter for StandardFrame object, no mousetrap found", "Skin Error", 0, "");
		}
	}
}

groupStandardFrame.onNotify(String strCommandPair, String strParam, Int intA, Int intB) {
	String strCommand = System.getToken(strCommandPair, ",", 0);
	String strCommandParam = System.getToken(strCommandPair, ",", 1);
	if (strCommand == "content" || strCommand == "padtitleright" || strCommand == "padtitleleft" || strCommand == "shade") {
		System.onSetXuiParam(strCommand, strCommandParam);
	}
}

setNewGroup(String strGroupID) {
	groupStandardFrameContent = System.newGroup(strGroupID);
	if (groupStandardFrameContent == NULL) {
		messagebox("group \"" + strGroupID + "\" not found", "ButtonGroup", 0, "");
		return;
	}
	groupStandardFrameContent.setXMLParam("x", strParamX);
	groupStandardFrameContent.setXMLParam("y", strParamY);
	groupStandardFrameContent.setXMLParam("w", strParamW);
	groupStandardFrameContent.setXMLParam("h", strParamH);
	groupStandardFrameContent.setXMLParam("relatx", strParamRX);
	groupStandardFrameContent.setXMLParam("relaty", strParamRY);
	groupStandardFrameContent.setXMLParam("relatw", strParamRW);
	groupStandardFrameContent.setXMLParam("relath", strParamRH);
	groupStandardFrameContent.init(groupStandardFrame);
}

initStyle() {
	strStandardFrameStyleTargetsBackgrounds1 = "window.main.topleft;window.main.topmiddle;window.main.topright;window.main.middleleft;window.main.middleright;window.main.middleleft2;window.main.middleright2;window.main.bottomleft;window.main.bottommiddle;window.main.bottomright";
	strStandardFrameStyleTargetsBackgrounds2 = "window.main.footer.left;window.main.footer.middle;window.main.footer.right;window.main.shortfooter.left;window.main.shortfooter.middle;window.main.shortfooter.right;window.main.titlebar.left;window.main.titlebar.middle";
	strStandardFrameStyleTargetsBackgrounds3 = "window.main.titlebar.right;window.title.inset;window.title.pl;window.title.ml;window.title.vid;window.title.avs;window.title.notifier";
	strStandardFrameStyleTargetsSoftButtons = "window.button.system;window.button.switch;window.button.close";
	
	syncStyle();
}

syncStyle() {
	String strStyle;
	
	if (configAttribute_styleCarbonWindows.getData() == "1") strStyle = "carbon"; else strStyle = "default";
	for (Int i = 0; i < (strCharCount(strStandardFrameStyleTargetsBackgrounds1, ";") + 1); i++) setStyle(layoutStandardFrame.findObject(System.getToken(strStandardFrameStyleTargetsBackgrounds1, ";", i)), strStyle);
	for (Int i = 0; i < (strCharCount(strStandardFrameStyleTargetsBackgrounds2, ";") + 1); i++) setStyle(layoutStandardFrame.findObject(System.getToken(strStandardFrameStyleTargetsBackgrounds2, ";", i)), strStyle);
	for (Int i = 0; i < (strCharCount(strStandardFrameStyleTargetsBackgrounds3, ";") + 1); i++) setStyle(layoutStandardFrame.findObject(System.getToken(strStandardFrameStyleTargetsBackgrounds3, ";", i)), strStyle);
	
	if (configAttribute_styleCarbonSoftButtons.getData() == "1") strStyle = "carbon"; else strStyle = "default";
	for (Int i = 0; i < (strCharCount(strStandardFrameStyleTargetsSoftButtons, ";") + 1); i++) setStyle(layoutStandardFrame.findObject(System.getToken(strStandardFrameStyleTargetsSoftButtons, ";", i)), strStyle);
}

configAttribute_styleDefaultAll.onDataChanged() { syncStyle(); }
configAttribute_styleCarbonAll.onDataChanged() { syncStyle(); }
configAttribute_styleDefaultWindows.onDataChanged() { syncStyle(); }
configAttribute_styleCarbonWindows.onDataChanged() { syncStyle(); }
configAttribute_styleDefaultSoftButtons.onDataChanged() { syncStyle(); }
configAttribute_styleCarbonSoftButtons.onDataChanged() { syncStyle(); }