Function initVisualizers();
Function unloadVisualizers();
Function refreshVisualizers();
Function setMainNormalVisualizer(Int intVisMode);
Function setMainNormalSideVisualizers(Int intVisMode);

Global Timer timerVisRefresh;
Global Layer layerMainNormalVisMouseTrap;
Global Group groupMainNormalVisualizers;
Global Group groupMainNormalVis1;
Global Group groupMainNormalVis2;
Global Group groupMainNormalVis3;
Global Group groupMainNormalVis4;
Global Group groupMainNormalVis5;
Global Group groupMainNormalVis6;
Global Group groupMainNormalVis7;
Global AnimatedLayer layerMainNormalIntro;
Global AnimatedLayer layerMainNormalVis1;
Global AnimatedLayer layerMainNormalVis2;
Global AnimatedLayer layerMainNormalVis3;
Global AnimatedLayer layerMainNormalVisSideLeft;
Global AnimatedLayer layerMainNormalVisSideRight;
Global Int intValueLeftPrevious;
Global Int intValueRightPrevious;
Global Int intValueAveragePrevious;
Global Int intMainNormalVisSideLeftFrameCount;
Global Int intMainNormalVisSideRightFrameCount;
Global Int intMainNormalVisFrameCount;
Global Int intMainNormalVisMode;
Global Int intMainNormalSideVisMode;

initVisualizers() {
	groupMainNormalVisualizers = layoutMainNormal.findObject("player.normal.group.display.visualizers");
	layerMainNormalVisMouseTrap = layoutMainNormal.findObject("player.visualizer.mousetrap");
	groupMainNormalVis1 = layoutMainNormal.findObject("player.normal.group.display.vis.1");
	groupMainNormalVis2 = layoutMainNormal.findObject("player.normal.group.display.vis.2");
	groupMainNormalVis3 = layoutMainNormal.findObject("player.normal.group.display.vis.3");
	groupMainNormalVis4 = layoutMainNormal.findObject("player.normal.group.display.vis.4");
	groupMainNormalVis5 = layoutMainNormal.findObject("player.normal.group.display.vis.5");
	groupMainNormalVis6 = layoutMainNormal.findObject("player.normal.group.display.vis.6");
	groupMainNormalVis7 = layoutMainNormal.findObject("player.normal.group.display.vis.7");
	
	layerMainNormalIntro = layoutMainNormal.findObject("player.intro");
	
	layerMainNormalVis1 = layoutMainNormal.findObject("player.vis.5");
	layerMainNormalVis2 = layoutMainNormal.findObject("player.vis.6");
	layerMainNormalVis3 = layoutMainNormal.findObject("player.vis.7");
	layerMainNormalVisSideLeft = layoutMainNormal.findObject("player.visualizer.side.left");
	layerMainNormalVisSideRight = layoutMainNormal.findObject("player.visualizer.side.right");
	
	intMainNormalVisFrameCount = layerMainNormalVis1.getLength();
	intMainNormalVisSideLeftFrameCount = layerMainNormalVisSideLeft.getLength();
	intMainNormalVisSideRightFrameCount = layerMainNormalVisSideRight.getLength();
	
	intMainNormalVisMode = System.getPrivateInt(System.getSkinName(), "MainNormalVisualizerMode", 1);
	intMainNormalSideVisMode = System.getPrivateInt(System.getSkinName(), "MainNormalSideVisualizerMode", 1);
	
	setMainNormalSideVisualizers(intMainNormalSideVisMode);
	
	timerVisRefresh = new Timer;
	timerVisRefresh.setDelay(10);
	timerVisRefresh.start();
	
	layerMainNormalIntro.play();
}

unloadVisualizers() {
	timerVisRefresh.stop();
	delete timerVisRefresh;
}

layerMainNormalIntro.onStop() {
	layerMainNormalIntro.hide();
	groupMainNormalVisualizers.setAlpha(0);
	groupMainNormalVisualizers.setTargetA(255);
	groupMainNormalVisualizers.setTargetSpeed(0.75);
	groupMainNormalVisualizers.show();
	groupMainNormalVisualizers.gotoTarget();
	setMainNormalVisualizer(intMainNormalVisMode);
}

timerVisRefresh.onTimer() {
	refreshVisualizers();
}

layerMainNormalVisMouseTrap.onLeftButtonDown(Int intPosX, Int intPosY) {
	if (System.isKeyDown(VK_CONTROL)) {
		groupMainNormalVisualizers.hide();
		layerMainNormalIntro.show();
		layerMainNormalIntro.play();
	} else {
		setMainNormalVisualizer(intMainNormalVisMode + 1);
	}
}

layerMainNormalVisMouseTrap.onRightbuttonUp(Int intPosX, Int intPosY) {
	PopupMenu popupVisualizations;
	Int intSelection;
	
	popupVisualizations = new PopupMenu;
	popupVisualizations.addCommand("Off", 0, (intMainNormalVisMode == 0), 0);
	popupVisualizations.addSeparator();
	popupVisualizations.addCommand("Spectrum Analyzer", 1, (intMainNormalVisMode == 1), 0);
	popupVisualizations.addCommand("Mirrored Double Spectrum Analyzer", 2, (intMainNormalVisMode == 2), 0);
	popupVisualizations.addCommand("Oscilliscope", 3, (intMainNormalVisMode == 3), 0);
	popupVisualizations.addCommand("Mirrored Double Spectrum Oscilliscope", 4, (intMainNormalVisMode == 4), 0);
	popupVisualizations.addSeparator();
	popupVisualizations.addCommand("Gyroscopic Feedback", 5, (intMainNormalVisMode == 5), 0);
	popupVisualizations.addCommand("Bad Science on Headphones", 6, (intMainNormalVisMode == 6), 0);
	popupVisualizations.addCommand("Socket Scratch", 7, (intMainNormalVisMode == 7), 0);
	
	intSelection = popupVisualizations.popAtMouse();
	if (intSelection > -1) {
		setMainNormalVisualizer(intSelection);
	}
	
	delete popupVisualizations;
	complete;
}

setMainNormalVisualizer(Int intVisMode) {
	groupMainNormalVis1.hide();
	groupMainNormalVis2.hide();
	groupMainNormalVis3.hide();
	groupMainNormalVis4.hide();
	groupMainNormalVis5.hide();
	groupMainNormalVis6.hide();
	groupMainNormalVis7.hide();
		
	if (intVisMode == 1) {
		groupMainNormalVis1.show();
	} else if (intVisMode == 2) {
		groupMainNormalVis2.show();
	} else if (intVisMode == 3) {
		groupMainNormalVis3.show();
	} else if (intVisMode == 4) {
		groupMainNormalVis4.show();
	} else if (intVisMode == 5) {
		groupMainNormalVis5.show();
	} else if (intVisMode == 6) {
		groupMainNormalVis6.show();
	} else if (intVisMode == 7) {
		groupMainNormalVis7.show();
	} else if (intVisMode > 7) {
		intVisMode = 0;
	}
	
	intMainNormalVisMode = intVisMode;
	System.setPrivateInt(System.getSkinName(), "MainNormalVisualizerMode", intMainNormalVisMode);
}

layerMainNormalVisSideLeft.onLeftButtonDown(Int intPosX, Int intPosY) { setMainNormalSideVisualizers(intMainNormalSideVisMode + 1); }
layerMainNormalVisSideRight.onLeftButtonDown(Int intPosX, Int intPosY) { setMainNormalSideVisualizers(intMainNormalSideVisMode + 1); }

setMainNormalSideVisualizers(Int intVisMode) {
	if (intVisMode == 1) {
		layerMainNormalVisSideLeft.setXMLParam("image", "player.normal.animation.visualizer.side.left.1");
		layerMainNormalVisSideRight.setXMLParam("image", "player.normal.animation.visualizer.side.right.1");
	} else if (intVisMode == 2)  {
		layerMainNormalVisSideLeft.setXMLParam("image", "player.normal.animation.visualizer.side.left.2");
		layerMainNormalVisSideRight.setXMLParam("image", "player.normal.animation.visualizer.side.right.2");
	} else if (intVisMode == 3)  {
		layerMainNormalVisSideLeft.setXMLParam("image", "player.normal.animation.visualizer.side.left.3");
		layerMainNormalVisSideRight.setXMLParam("image", "player.normal.animation.visualizer.side.right.3");
	} else if (intVisMode == 4)  {
		layerMainNormalVisSideLeft.setXMLParam("image", "player.normal.animation.visualizer.side.left.4");
		layerMainNormalVisSideRight.setXMLParam("image", "player.normal.animation.visualizer.side.right.4");
	} else if (intVisMode > 4) {
		intVisMode = 0;
	}
	
	intMainNormalSideVisMode = intVisMode;
	System.setPrivateInt(System.getSkinName(), "MainNormalSideVisualizerMode", intMainNormalSideVisMode);
}

refreshVisualizers() {
	Int intValueLeft;
	Int intValueRight;
	Int intValueAverage;
	
	if (intMainNormalSideVisMode != 0) {
		intValueLeft = System.getLeftVuMeter();
		intValueRight = System.getRightVuMeter();
	} else {
		intValueLeft = 0;
		intValueRight = 0;
	}
	
	if (intMainNormalVisMode > 4) {
		intValueAverage = (System.getLeftVuMeter() + System.getRightVuMeter()) / 2;
	} else {
		intValueAverage = 0;
	}
	
	if (intValueLeft < intValueLeftPrevious) intValueLeft = intValueLeftPrevious - ((255 * intMainNormalVisSideLeftFrameCount - 1) / 255);
	if (intValueRight < intValueRightPrevious) intValueRight = intValueRightPrevious - ((255 * intMainNormalVisSideRightFrameCount - 1) / 255);
	if (intValueAverage < intValueAveragePrevious) intValueAverage = intValueAveragePrevious - (((255 * intMainNormalVisFrameCount - 1) / 255) / 2);
	
	if (intValueLeft < 0) intValueLeft = 0;
	if (intValueRight < 0) intValueRight = 0;
	if (intValueAverage < 0) intValueAverage = 0;
	
	Int intMainNormalVisSideLeftFrame = (intValueLeft * intMainNormalVisSideLeftFrameCount - 1) / 255;
	Int intMainNormalVisSideRightFrame = (intValueRight * intMainNormalVisSideRightFrameCount - 1) / 255;
	Int intMainNormalVisFrame = (intValueAverage * intMainNormalVisFrameCount - 1) / 255;
	
	layerMainNormalVisSideLeft.gotoFrame(intMainNormalVisSideLeftFrame);
	layerMainNormalVisSideRight.gotoFrame(intMainNormalVisSideRightFrame);
	
	layerMainNormalVis1.gotoFrame(intMainNormalVisFrame);
	layerMainNormalVis2.gotoFrame(intMainNormalVisFrame);
	layerMainNormalVis3.gotoFrame(intMainNormalVisFrame);
	
	intValueLeftPrevious = intValueLeft;
	intValueRightPrevious = intValueRight;
	intValueAveragePrevious = intValueAverage;
}
